Subject: Re: Understanding lock contention in __udp4_lib_mcast_deliver

From: Rick Jones <[email-masked]>
Date: Thu, 27 Jun 2013 12:58:39 -0700

On 06/27/2013 12:22 PM, Shawn Bohrer wrote:
> I'm looking for opportunities to improve the multicast receive
> performance for our application, and I thought I'd spend some time
> trying to understand what I thought might be a small/simple
> improvement.  Profiling with perf I see that there is spin_lock
> contention in __udp4_lib_mcast_deliver:
>
> 0.68%  swapper  [kernel.kallsyms]               [k] _raw_spin_lock
>         |
>         --- _raw_spin_lock
>            |
>            |--24.13%-- perf_adjust_freq_unthr_context.part.21
>            |
>            |--22.40%-- scheduler_tick
>            |
>            |--14.96%-- __udp4_lib_mcast_deliver

Are there other processes showing _raw_spin_lock time?  It may be more 
clear to add a --sort symbol,dso or some such to your perf report 
command.  Because what you show there suggests less than 1% of the 
active cycles are in _raw_spin_lock.

rick jones